// 
// choubi : Fri Apr 29 15:44:20 2005
// Patron pour la generation d'une classe derivee dans ROOT
// Correl3 derive de TNamed
// 
// 
 
//#include "DataMergerOneTrigger.C"
#include "DataMergerGroup.C"
#include "DMThick.C"
#include "DMThickThin.C"

#define Correl3_cxx 
 
#include "Riostream.h"
 
#include "Correl3.h"
#include "FHistAtt.h"
#include "FParamBrut.h"
#include "TStringLong.h"
#include "TRandom3.h"
#include "TTimeStamp.h"
#include "FParamBrutPersistant.h"
#include "FParamBrutSimple.h"
#include "FParamCalc.h"
#include "TSystem.h"
#include "TFile.h"
#include "TDirectory.h"
 
ClassImp(Correl3)
/////////////////////////////////////////////////////////////////////////
// Insert here the Correl3 class description
//
//


//_________________________________________________________
void Correl3::Init(void)
 {
//
// Initialisation
//
 validDelay=0;
 validGate=0;
 bench.Reset();
 trigRHB=kTRUE;
 TSThick4=-1;
 TSThin4=-1;
 TSCsI4=-1;
 }
 
//_________________________________________________________
Correl3::Correl3(void):FEventProcessorThread()
 {
// 
// Constructeur par Defaut
//
 Init();
 cout << "Creation de Correl3..." << endl;
 }
 
 
//_________________________________________________________
Correl3::Correl3(const Correl3 &hp):FEventProcessorThread(hp)
 {
// 
// Constructeur par Copie
//
 Init();
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
  hp.Copy(*this);
#else
  ((Correl3 &)a).Copy(*this);
#endif
 }
 
//_________________________________________________________
Correl3::~Correl3(void)
 {
//
// Destructeur
//
 }
  
//_________________________________________________________
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
void Correl3::Copy(TObject &hp) const
#else
void Correl3::Copy(TObject &hp)
#endif
 {
//
// Copie
//
 FEventProcessor::Copy(hp);
 }
 
//_________________________________________________________
Correl3& Correl3::operator = (const Correl3 &hp)
 {
//
// Operateur =
//
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   hp.Copy(*this);
#else
   ((Correl3 &)hp).Copy(*this);
#endif
 return *this;
 }
 
//_________________________________________________________
void Correl3::InitParams(void)
 {
//
// Initialisation of the param list
// Add parameters to the listOfParams list
//
 
 // The following line is mandatory if you use a FDataReader: this will get
 // the FParamBrut parameters from the FDataReader and add them to the list of
 // parameters.
 FEventProcessor::InitParams();
 
 // enter your code from here
 // Parametres de base arrivant les uns a la suite des autres
 // Lecture du fichier d'environnement 
 TString rhbFilesDirectory=gSystem->Getenv("RHBROOT");
 if(!rhbFilesDirectory.Length()) env.ReadFile(Form("%s/etc/system.RHBrc","/usr/share/rhb"),kEnvGlobal);
 else env.ReadFile(Form("%s/etc/system.RHBrc",gSystem->Getenv("RHBROOT")),kEnvGlobal);
 env.ReadFile(Form("%s/.RHBrc",gSystem->Getenv("HOME")),kEnvUser);
 env.ReadFile("./.RHBrc",kEnvLocal);
 thickOnly=env.GetValue("Correl3.thickOnly",kTRUE);
 cout << "ThickOnly : " << thickOnly << endl;
 TString readFile=env.GetValue("FFileDevice.FileName","");
 if(readFile.Length())
  {
  trigRHB=!readFile.Contains("thick");
  }
 //
 // Declaration des DataMergerGroup pour chaque telescope
 //
 for(Int_t nTel=1;nTel<=5;nTel++)
  {
  DataMergerGroup *dm=0;
  cout << "  -----> Creation d'un ";
  if(thickOnly)
   {
   cout << "DMThick ";
   dm=new DMThick();
   }
  else
   {
   cout << "DMThickThin ";
   dm=new DMThickThin();
   }
  dm->SetName(Form("ThkThn%d",nTel));
  cout << ": " << dm->GetName() << " pour le telescope " << nTel << endl;  
  dataMerger.Add(dm);
  // Parametres du trigger: Silicium epais
  FParam *p=this->GetParam(Form("ADC_thick_tel%d",nTel));
  FParam *t=this->GetParam(Form("ts_ADC_thick_tel%d",nTel));
  FParam *out=0;
  FParam *outTS=0;
  dm->AddTriggerParam(p,t,out,outTS);
  this->AddParam(out);
  this->AddParam(outTS);
  
  // Parametre trigger: Silicium fin
  p=this->GetParam(Form("ADC_thin_tel%d",nTel));
  t=this->GetParam(Form("ts_ADC_thin_tel%d",nTel));
  out=0;
  outTS=0;
  if(thickOnly)
   {
   cout << p->GetName() << " as slave" << endl;
   dm->AddSlaveParam(p,t,out,outTS);
   }
  else
   {
   cout << p->GetName() << " as trigger" << endl;
   dm->AddTriggerParam(p,t,out,outTS);
   }
  this->AddParam(out);
  this->AddParam(outTS);

 
  // Parametre esclave: CsI rapide
  p=this->GetParam(Form("QDC2_CsI_tel%d",nTel));
  t=this->GetParam(Form("ts_QDC_CsI_tel%d",nTel));
  out=0;
  outTS=0;
  dm->AddSlaveParam(p,t,out,outTS);
  this->AddParam(out);
  this->AddParam(outTS);
  
  }
 
 
 validDelay=0; 
 validGate=0;
 scanGate=0;

 for(Int_t nTel=1;nTel<=5;nTel++)
  {
  // Ajout des compteurs sur les correlation
  FParam *p=new FParamBrutSimple();
  p->SetName(Form("nbThickPerTrig%d",nTel));
  this->AddParam(p);
  p=new FParamBrutSimple();
  p->SetName(Form("nbThinPerTrig%d",nTel));
  this->AddParam(p);
  p=new FParamBrutSimple();
  p->SetName(Form("nbCsIPerTrig%d",nTel));
  this->AddParam(p);
  }
 }

//_________________________________________________________
void Correl3::InitHistos(void)
 {
//
// Declaration of FHistograms
// Please add them to the listOfHistos list
//
 
 bench.Start("Traitement");
 
 }

//_________________________________________________________
void Correl3::SetParamValues(void)
 {
//
// Set the parameter values here from the "raw" event
// please retrieve parameters from the listOfParams list
// if the value is set to a parameter, please add it to the listOfHitParams
// 
 // The following line is mandatory if you use a FDataReader: this will set
 // the FParamBrut values from the FDataReader.
 FEventProcessor::SetParamValues();
 
 if(stop)
  {
  bench.Stop("Traitement");
  bench.Print("Traitement");
  }
 
 // enter your code from here
 // On va chercher les valeurs des fenetres de validation
 if(!validDelay)
  {
  validDelay=this->GetParam("ValidDelay");
  }
 if(!validGate)
  {
  validGate=this->GetParam("ValidGate");
  }
 if(!scanGate)
  {
  scanGate=this->GetParam("ScanGate");
  }


 // on va boucler sur les DataMerger de la liste
 TIter nextDM(&dataMerger);
 DataMergerGroup *dm=0;
 while((dm=(DataMergerGroup *)nextDM()))
  {
  // On ajuste les valeurs de la fenetre de validation sur la DataMergerOneTrigger
  dm->SetCollectionDelay(validDelay->GetValue());
  dm->SetCollectionGate(validGate->GetValue());
  dm->SetDecisionGate(scanGate->GetValue());

  // On procede au traitement
  dm->Process();
  }
 
 // On va maintenant verifier si un groupe est active
 if(trigRHB)
  {
  for(Int_t nTel=1;nTel<=5;nTel++)
   {
   FParam *p=GetParam(Form("ThkThn%d_ADC_thick_tel%d",nTel,nTel));
   if(p)
    {
    if(p->IsOn())
     {
     GetParam(Form("nbThickPerTrig%d",nTel))->SetValue(p->GetNbValues());
     p=GetParam(Form("ThkThn%d_ADC_thin_tel%d",nTel,nTel));
     if(p->IsOn()) 
      {GetParam(Form("nbThinPerTrig%d",nTel))->SetValue(p->GetNbValues());}
      else
      {GetParam(Form("nbThinPerTrig%d",nTel))->SetValue(0.);}
     p=GetParam(Form("ThkThn%d_QDC2_CsI_tel%d",nTel,nTel));
     if(p->IsOn()) 
      {GetParam(Form("nbCsIPerTrig%d",nTel))->SetValue(p->GetNbValues());}
     else
      {GetParam(Form("nbCsIPerTrig%d",nTel))->SetValue(0.);}
     }
    }
   }
  }
 else
  {
  for(Int_t nTel=1;nTel<=5;nTel++)
   {
   FParam *p=GetParam(Form("ADC_thick_tel%d",nTel));
   if(p)
    {
    if(p->IsOn())
     {
     GetParam(Form("nbThickPerTrig%d",nTel))->SetValue(p->GetNbValues());
     p=GetParam(Form("ADC_thin_tel%d",nTel));
     if(p->IsOn()) 
      {GetParam(Form("nbThinPerTrig%d",nTel))->SetValue(p->GetNbValues());}
      else
      {GetParam(Form("nbThinPerTrig%d",nTel))->SetValue(0.);}
     p=GetParam(Form("QDC2_CsI_tel%d",nTel));
     if(p->IsOn()) 
      {GetParam(Form("nbCsIPerTrig%d",nTel))->SetValue(p->GetNbValues());}
     else
      {GetParam(Form("nbCsIPerTrig%d",nTel))->SetValue(0.);}
     }
    }
   }
  }

 // Remplissage des histogrammes DeltaTS
 validGate->SetOff();
 FParam *p=GetParam("ts_ADC_thick_tel4");
 if(p->IsOn())
  {
  TH1 *h=(TH1 *)listOfHistos->FindObject("DeltaTSThickTel4");
  if(h)
   {
   Double_t t=p->GetValue()*7.8125e-3;
   if(TSThick4 > 0)
    {
    h->Fill(t-TSThick4);
    }
   TSThick4=t;
   }
  }
 p=GetParam("ts_ADC_thin_tel4");
 if(p->IsOn())
  {
  TH1 *h=(TH1 *)listOfHistos->FindObject("DeltaTSThinTel4");
  if(h)
   {
   Double_t t=p->GetValue()*7.8125e-3;
   if(TSThin4 > 0)
    {
    h->Fill(t-TSThin4);
    }
   TSThin4=t;
   }
  }
 p=GetParam("ts_QDC_CsI_tel4");
 if(p->IsOn())
  {
  TH1 *h=(TH1 *)listOfHistos->FindObject("DeltaTSCsITel4");
  if(h)
   {
   Double_t t=p->GetValue()*7.8125e-3;
   if(TSCsI4 > 0)
    {
    h->Fill(t-TSCsI4);
    }
   TSCsI4=t;
   }
  }
   
 if(!(nevt%10000))
  {
  cout << nevt << " --> Je suis passe par la methode Correl3::SetParamValues() " <<endl;
  }
 }


// //_________________________________________________________
// Bool_t Correl3::IsRunning(void)
//  {
// //
// // Condition to process the next event
// // Uncomment this method if you want to set your own condition.
// //
//  
//  return kFALSE;
//  }

//_________________________________________________________
void Correl3::SaveHistos(void)
 {
//
// Called at the end of the process. Save your histograms here
// Uncomment this method in case you want to implement this method.
//  
 TString readFile=env.GetValue("FFileDevice.FileName","");
 if(readFile.Length())
  {
  readFile.ReplaceAll("_0001.fast","");
  if(!trigRHB)
   {
   readFile.Prepend("JH_");
   }
  else
   {
   readFile.Append("_thick");
   if(!thickOnly)
    {
    readFile.Append("_thin");
    }
   if(validGate->GetValue() == 100.)
    {
    readFile.Prepend("smallGate_");
    }
   readFile.Prepend("RHB_");
   }
  readFile.Append(".root");
  TFile *f=new TFile(readFile.Data(),"RECREATE");
  f->cd();
  FEventProcessor::SaveHistos();
  }
 }

// //_________________________________________________________
// Bool_t Correl3::DoPlotTempo(void)
//  {
// //
// // Condition to make a temporary plot or to print a intermediate message
// // Uncomment this method in case you want to implement this method.
// // 
//  
//  return kFALSE;
//  }

// //_________________________________________________________
// void Correl3::PlotTempo(void)
//  {
// //
// // Make a temporary plot or to print a intermediate message
// // Uncomment this method in case you want to implement this method.
// // 
//  
//  }
