// 
// Patron pour la generation d'une classe derivee dans ROOT
// FMultiParam1DAtt derive de FScaleAtt
// 
 
#ifndef FMultiParam1DAtt_h 
#define FMultiParam1DAtt_h 
 
#include "FScaleAtt.h" 
 
class FMultiParam1DAtt : public FScaleAtt { 
 
   protected: 
        virtual void Init(void);       // initialisation 
 
   public:	 
   	FMultiParam1DAtt(void);    // constructeur par defaut 
	FMultiParam1DAtt(const FMultiParam1DAtt &ap); // constructeur par copie 
	
	~FMultiParam1DAtt(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void CopyHistAtt(FHistAtt & obj) const;
#else
   	virtual void CopyHistAtt(FHistAtt & obj);
#endif
	FMultiParam1DAtt& operator = (const FMultiParam1DAtt &hp); // operateur = 
 
	virtual void FillHist(Stat_t w=1.);

 	virtual void WriteInFile(ofstream &fout);
	virtual Bool_t  ReadInFile(ifstream &fin, TList *lop);
	virtual TList *GenericBuilding(TList *lop=0,TList *los=0,
				      FGenericName *name=0,
				      FGenericName *title=0,
				      FGenericName *paramX=0,
				      Int_t nx=0,Double_t xmin=0.,Double_t xmax=0.,
				      FGenericName *paramY=0,
				      Int_t ny=0,Double_t ymin=0.,Double_t ymax=0.,
				      FGenericName *cond=0);

 	virtual void AddParam(FParam *p){FHistAtt::AddParam(p);};
	virtual void AddParamAt(Int_t i,FParam *p){FHistAtt::AddParamAt(i,p);};
	virtual void RemoveParams(void){FHistAtt::RemoveParams();};
	virtual void RemoveParamAt(Int_t i){FHistAtt::RemoveParamAt(i);};

   ClassDef(FMultiParam1DAtt,1)
 
}; 
 
#endif 
 
