// 
// Patron pour la generation d'une classe derivee dans ROOT
// FNetConnection derive de TNamed
// 
 
#ifndef FNetConnection_h 
#define FNetConnection_h 
 
#include "TNamed.h" 
#include "TSocket.h" 
#include "TMessage.h" 

//#define HANDLE_SOCKET_BLOCKING
 
class FNetConnection : public TNamed { 
 
   protected: 
	static Int_t Debug;

   	TSocket *sock;

   protected: 
        virtual void Init(void);       // initialisation 
 
   public:	 
        static void SetDebug(Int_t d=0) {FNetConnection::Debug=d;}
        static Int_t GetDebug(void) {return FNetConnection::Debug;}
	
   	FNetConnection(void);    // constructeur par defaut 
	FNetConnection(const FNetConnection &ap); // constructeur par copie 
	
	~FNetConnection(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	FNetConnection& operator = (const FNetConnection &hp); // operateur = 
 
 	virtual void InitSocket(const Char_t *ser=0, Int_t port=0);
	virtual void ReleaseSocket(void);
	virtual TMessage *SendString(const Char_t *command, Bool_t expectAnswser=kFALSE);
	virtual TMessage *SendObject(TObject *o, Bool_t expectAnswser=kFALSE);
	virtual TObject *GetObject(Char_t *nom);
	virtual TSocket *GetSocket(void) const {return sock;}

    ClassDef(FNetConnection,1)
 
}; 
 
#endif 
 
