// 
// Patron pour la generation d'une classe derivee dans ROOT
// FScaleAtt derive de FHistAtt
// 
 
#ifndef FScaleAtt_h 
#define FScaleAtt_h 
 
#include "FHistAtt.h" 
 
class FScaleAtt : public FHistAtt { 
 
   protected: 
	Bool_t	rebin;

   protected: 
        virtual void Init(void);       // initialisation 
 
   public:	 
   	FScaleAtt(void);    // constructeur par defaut 
	FScaleAtt(const FScaleAtt &ap); // constructeur par copie 
	
	~FScaleAtt(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void CopyHistAtt(FHistAtt & obj) const;
#else
   	virtual void CopyHistAtt(FHistAtt & obj);
#endif
	FScaleAtt& operator = (const FScaleAtt &hp); // operateur = 
 
	virtual void AddParam(FParam *p);
	virtual void AddParamAt(Int_t i,FParam *p);
	virtual void RemoveParams(void);
	virtual void RemoveParam(FParam *p);
	virtual void RemoveParam(Char_t *np);
	virtual void RemoveParamAt(Int_t i);

	virtual void FillHist(Stat_t w=1.);

 	virtual void WriteInFile(ofstream &fout);
 	virtual Bool_t  ReadInFile(ifstream &fin, TList *lop);
	virtual TList *GenericBuilding(TList *lop=0,TList *los=0,
				      FGenericName *name=0,
				      FGenericName *title=0,
				      FGenericName *paramX=0,
				      Int_t nx=0,Double_t xmin=0.,Double_t xmax=0.,
				      FGenericName *paramY=0,
				      Int_t ny=0,Double_t ymin=0.,Double_t ymax=0.,
				      FGenericName *cond=0);
	

    ClassDef(FScaleAtt,1)
 
}; 
 
#endif 
 
