// 
// Patron pour la generation d'une classe derivee dans ROOT
// FTimeProfileAtt derive de FTimeHistAtt
// 
 
#ifndef FTimeProfileAtt_h 
#define FTimeProfileAtt_h 
 
#include "FTimeHistAtt.h" 
 
class FTimeProfileAtt : public FTimeHistAtt { 
 
   protected: 
        virtual void Init(void);       // initialisation 
 	virtual void DoShift(Int_t ishift);
	virtual void FillTimeHist(Double_t time, FParam *p, Stat_t w=1.);
 
   public:	 
   	FTimeProfileAtt(void);    // constructeur par defaut 
	FTimeProfileAtt(const FTimeProfileAtt &ap); // constructeur par copie 
	
	~FTimeProfileAtt(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void CopyHistAtt(FHistAtt & obj) const;
#else
   	virtual void CopyHistAtt(FHistAtt & obj);
#endif
	FTimeProfileAtt& operator = (const FTimeProfileAtt &hp); // operateur = 
 
 	virtual void WriteInFile(ofstream &fout);
 	virtual Bool_t  ReadInFile(ifstream &fin, TList *lop);
	virtual TList *GenericBuilding(TList *lop=0,TList *los=0,
				      FGenericName *name=0,
				      FGenericName *title=0,
				      FGenericName *paramX=0,
				      Int_t nx=0,Double_t xmin=0.,Double_t xmax=0.,
				      FGenericName *paramY=0,
				      Int_t ny=0,Double_t ymin=0.,Double_t ymax=0.,
				      FGenericName *cond=0);

    ClassDef(FTimeProfileAtt,1)
 
}; 
 
#endif 
 
