//
// Patron pour la generation d'une classe derivee dans ROOT
// FWindowH2F derive de TH1F
//

#ifndef FWindowH2F_h
#define FWindowH2F_h

#include "TH2F.h"
#include "FWindowHistAtt.h"

class FWindowH2F : public TH2F, public FWindowHistAtt {

  protected:
    virtual void Init(void);       // initialisation

  public:
    FWindowH2F(void);    // constructeur par defaut
    FWindowH2F(const char* name, const char* title, Int_t nbinsx, Int_t nbinsy, Axis_t ylow, Axis_t yup);
    FWindowH2F(const char* name, const char* title, Int_t nbinsx, Int_t nbinsy, const Double_t* ybins);
    FWindowH2F(const FWindowH2F &ap); // constructeur par copie

    ~FWindowH2F(void);		// desctructeur;

#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
    virtual void Copy(TObject & obj) const;
#else
    virtual void Copy(TObject & obj);
#endif
    FWindowH2F& operator = (const FWindowH2F &hp); // operateur =

    virtual TH1 *GetHisto(void);
    virtual void SavePrimitive(ostream &out, Option_t *opt="");

    virtual void Paint(Option_t *option="");

    ClassDef(FWindowH2F,1)

};

#endif

